c     Copyright (C)
c     2000 -2013 Universite Paul Sabatier,
c     2000 -2013 Centre National de la Recherche Scientifique
c     2000 -2013 Ecole des Mines d'Albi
c     2014-2018 Msostar
c
c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine mesh()

      implicit none

      include 'max.inc'
      include 'data.inc'
      include 'param.inc'
      include 'files_in.inc'
      include 'formats.inc'

      integer i,ios,ep
      double precision sum

c     Cette routine dfinit de quelle faon l'atmosphre est maille.

      if (raz.eq.1) then
         open(11,file='temporary/mesh.sav')
         read(11,*) m,H,Tm
         read(11,50) (alti(i),i=0,2*(m-1))
         read(11,50) (alt(i),i=0,m-1)
         read(11,50) (e(i),i=0,m)
         read(11,50) (pres(i),i=0,m-1)
         read(11,50) (temp(i),i=0,m-1),Tsol,Tesp
         read(11,50) (dens(i),i=0,m-1)
         read(11,50) (adia(i),i=0,m-1)
         read(11,50) (grav(i),i=0,m-1)
         read(11,50) (zeta(i),i=0,m-1)
         read(11,50) (capa(i),i=0,m-1)
         close(11)
         goto 1234
      endif

c     Rcupration des donnes pour l'atmopshre tropicale
      open(10,file=file_ray,status='old',iostat=ios)
      if (ios.ne.0) then ! file not found
         call screen(1146,0,0,0.0D+0,0.0D+0)
         stop
      endif
      call screen(10,0,0,0.0D+0,0.0D+0)
      read(10,*) n ! Lecture du nombre d'altitudes donnes dans le fichier
      m=n ! Nombre de mailles de gaz pour le calcul
c     Un test rapide
      if (m.gt.Nmax) then
         call screen(1403,m,Nmax,0.0D+0,0.0D+0)
         call screen(15,0,0,0.0D+0,0.0D+0)
         call screen(44,0,0,0.0D+0,0.0D+0)
         stop
      endif
      read(10,50) (alt(i),i=0,m-1)  ! Les donnes d'altitude
      read(10,50) (e(i),i=0,m)      ! Le maillage de calcul
      read(10,50) (pres(i),i=0,m-1)   ! Les pressions
      read(10,50) (temp(i),i=0,m-1),Tsol,Tesp ! Les tempratures
      read(10,50) (dens(i),i=0,m-1) ! les densits
      read(10,50) (adia(i),i=0,m-1) ! adiabatic lapse rates
      read(10,50) (grav(i),i=0,m-1) ! acclration de la gravit
      read(10,50) (zeta(i),i=0,m-1) ! coefficient de non-idalit
      read(10,50) (capa(i),i=0,m-1) ! capacits calorifiques
      close(10)
c     Une petite scurit dans le cas o toutes les pressions sont les mmes, ce
c     qui va crer des NaN au moment de calculer les taux de chauffage
      ep=1
      do i=1,m-1
         if (pres(i).ne.pres(0)) then
            ep=0
            goto 332
         endif
      enddo
 332  continue
      if (ep.eq.1) then
         pres(0)=1013.0D+2 ! Pa
         pres(m-1)=1.0D+3 ! Pa
         do i=1,m-2
            pres(i)=pres(0)-(pres(0)-pres(m-1))/(m-1)*i ! Pa
         enddo
      endif
      
      call postmesh()

      open(11,file='temporary/mesh.sav')
      write(11,*) m,H,Tm
      write(11,50) (alti(i),i=0,2*(m-1))
      write(11,50) (alt(i),i=0,m-1)
      write(11,50) (e(i),i=0,m)
      write(11,50) (pres(i),i=0,m-1)
      write(11,50) (temp(i),i=0,m-1),Tsol,Tesp
      write(11,50) (dens(i),i=0,m-1)
      write(11,50) (adia(i),i=0,m-1)
      write(11,50) (grav(i),i=0,m-1)
      write(11,50) (zeta(i),i=0,m-1)
      write(11,50) (capa(i),i=0,m-1)
      close(11)

 1234 continue
      return
      end
