c     Copyright (C)
c     2000 -2013 Universite Paul Sabatier,
c     2000 -2013 Centre National de la Recherche Scientifique
c     2000 -2013 Ecole des Mines d'Albi
c     2014-2018 Msostar
c
c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine recombine_integrated_ner(m,ner,n,rner)
      implicit none
      include 'max.inc'
      integer m,i,j,n
      double precision ner(0:Nmax+1,0:Nmax+1)
      double precision rner(0:Nmax+1,0:Nmax+1)

c     Purpose: to recombine NERs for proper visualization
      n=m-2
c     layer 0 = ground
      rner(0,0)=0.0D+0
      rner(0,1)=ner(0,1)+ner(0,2)
      do j=2,n-1
         rner(0,j)=ner(0,j+1)
      enddo
      rner(0,n)=ner(0,m-1)+ner(0,m)
      rner(0,n+1)=ner(0,m+1)
c     layer 1
      rner(1,0)=ner(1,0)+ner(2,0)
      rner(1,1)=0.0D+0
      do j=2,n-1
         rner(1,j)=ner(1,j+1)+ner(2,j+1)
      enddo
      rner(1,n)=ner(1,m-1)+ner(2,m-1)+ner(1,m)+ner(2,m)
      rner(1,n+1)=ner(1,m+1)+ner(2,m+1)
c     layer i [2,n-1]
      do i=2,n-1
         rner(i,0)=ner(i+1,0)
         rner(i,1)=ner(i+1,1)+ner(i+1,2)
         do j=2,n-1
            rner(i,j)=ner(i+1,j+1)
         enddo
         rner(i,n)=ner(i+1,m-1)+ner(i+1,m)
         rner(i,n+1)=ner(i+1,m+1)
      enddo
c     layer n
      rner(n,0)=ner(m-1,0)+ner(m,0)
      rner(n,1)=ner(m-1,1)+ner(m-1,2)+ner(m,1)+ner(m,2)
      do j=2,n-1
         rner(n,j)=ner(m-1,j+1)+ner(m,j+1)
      enddo
      rner(n,n)=0.0D+0
      rner(n,n+1)=ner(m-1,m+1)+ner(m,m+1)
c     layer n+1
      rner(n+1,0)=ner(m+1,0)
      rner(n+1,1)=ner(m+1,1)+ner(m+1,2)
      do j=2,n-1
         rner(n+1,j)=ner(m+1,j+1)
      enddo
      rner(n+1,n)=ner(m+1,m-1)+ner(m+1,m)
      rner(n+1,n+1)=0.0D+0

      do i=0,n+1
         rner(i,i)=0.0D+0
      enddo

      return
      end
